// @ts-check

class Point {

    /**
     * 
     * @param {number} x 
     * @param {number} y 
     */
    constructor(x, y) {
        this.x = x;
        this.y = y;
    }

    /**
     * @param {Point} p 
     * @returns {number|undefined}
     */
    distanceTo(p) {
        return p instanceof Point ? Math.sqrt(Math.pow(p.x - this.x, 2) + Math.pow(p.y - this.y, 2)) : undefined;
    }
}

module.exports = Point;
